﻿class Circuit {
	#include "Constantes.as"

	private var longueur:Number;
	private var distanceRepet:Number;
	public var distanceParcourue:Number;
	public var tronconsParfaits:Number;
	private var dernierRepet:Number;
	public var dernierTroncon:Boolean;
	private var probaImpurete:Number
	
	public function Circuit(distanceRepet:Number, longueur:Number, probaImpurete:Number) {
		this.longueur = longueur;
		this.distanceRepet = distanceRepet;
		this.probaImpurete = probaImpurete;
		distanceParcourue = 0;
		tronconsParfaits = 0;
		dernierRepet = 0;
		dernierTroncon = false;
	}
	
	public function NouveauTroncon():Troncon {
		if (distanceParcourue > longueur) {
			dernierTroncon = true;
			return new Troncon(NBCERCLES, 1, 0, 0, 0, 0, 0, 0);
		} else if (distanceParcourue - dernierRepet >= distanceRepet) {
			dernierRepet = distanceParcourue;
			return new Troncon(5, TR_REPETITEUR, random(6)*Math.PI/3, 0, 0, 0, 0, 0);
		} else if (tronconsParfaits > 0) {
			tronconsParfaits--;
			return new Troncon(5+random(10), TR_PARFAIT, random(6)*Math.PI/3, random(30), 0, 0.02, 0.02, 0);
		} else {
			return new Troncon(5+random(10), TR_STANDARD, random(6)*Math.PI/3, random(30), probaImpurete, 0.02, 0.02, 0.1);			
		}
	}
	
}