﻿class Troncon {
	#include "Constantes.as"
	
	public var longueur:Number;
	public var posCourante:Number;
	public var type:Number;
	public var theta:Number;
	public var courbure:Number;
	public var couleur:flash.geom.ColorTransform;
	public var probaObjets:Array;

	public function Troncon(longueur:Number, type:Number, theta:Number, courbure:Number,
							probaImpurete:Number, probaTCP:Number, probaUDP:Number, probaFibreParfaite:Number){
		//Dans un premier temps, longueur >= NBCERCLES
		this.longueur=longueur;
		this.type=type;		
		this.theta=theta;
		this.courbure=courbure;
		probaObjets = [];
		probaObjets[OBJ_IMPURETE] = probaImpurete;
		probaObjets[OBJ_TCP] = probaTCP;
		probaObjets[OBJ_UDP] = probaUDP;
		probaObjets[OBJ_FIBREPARFAITE] = probaFibreParfaite;
		posCourante = 0;
		
		this.couleur = new flash.geom.ColorTransform;
		switch(type) {
			case TR_STANDARD:
				couleur.redMultiplier=Math.random();
				couleur.greenMultiplier=Math.random();
				couleur.blueMultiplier=Math.random();
				break;
			case TR_REPETITEUR:
				couleur.redMultiplier=0;
				couleur.greenMultiplier=0;
				couleur.blueMultiplier=1;
				break;
			case TR_PARFAIT:
				couleur.redMultiplier=1;
				couleur.greenMultiplier=0.8;
				couleur.blueMultiplier=0.30;
				break;
		}
	}
	
	public function NouveauSegment(z:Number, nom:String):Segment {
		posCourante++;
		return new Segment(z, this, posCourante, nom);
	}

}